perm

来自「实战Linux编程的原代码,希望对学驱动的人能有所帮助」· 代码 · 共 82 行

TXT
82
字号
#!/bin/sh# Make sure the permission-preserving code in copy.c (mv, cp, install) works.. $srcdir/../expensiveif test "$VERBOSE" = yes; then  set -x  cp --version  mv --versionfi. $srcdir/../envvar-checkpwd=`pwd`t0=`echo "$0"|sed 's,.*/,,'`.tmp;tmp=$t0/$$trap 'status=$?; cd $pwd; rm -rf $t0 && exit $status' 0trap '(exit $?); exit' 1 2 13 15framework_failure=0mkdir -p $tmp || framework_failure=1cd $tmp || framework_failure=1umask 037if test $framework_failure = 1; then  echo 'failure in testing framework'  exit 1fifail=0# Now, try it with `mv', with combinations of --force, no-f and# existing-destination and not.for u in 31 37 2; do  echo umask: $u  umask $u  for cmd in mv 'cp -p' cp; do    for force in '' -f; do      for existing_dest in yes no; do	for g_perm in r w x rw wx xr rwx; do	  for o_perm in r w x rw wx xr rwx; do	    touch src || exit 1	    chmod u=r,g=rx,o= src || exit 1	    set _ `ls -l src`	    shift	    expected_perms=$1	    rm -f dest	    test $existing_dest = yes && {	      touch dest || exit 1	      chmod u=rw,g=$g_perm,o=$o_perm dest || exit 1	      }	    $cmd $force src dest || exit 1	    test "$cmd" = mv && test -f src && exit 1	    test "$cmd" = cp && { test -f src || exit 1; }	    set _ `ls -l dest`	    shift	    case "$cmd:$force:$existing_dest" in	      cp:*:yes)		_g_perm=`echo rwx|sed 's/[^'$g_perm']/-/g'`		_o_perm=`echo rwx|sed 's/[^'$o_perm']/-/g'`		expected_perms=-rw-$_g_perm$_o_perm		;;	      cp:*:no)		test $u = 37 &&		  expected_perms=`echo $expected_perms|sed 's/.....$/-----/'`		test $u = 31 &&		  expected_perms=`echo $expected_perms|sed 's/..\(..\).$/--\1-/'`		;;	    esac	    test _$1 = _$expected_perms || exit 1	    # Perform only one iteration when there's no existing destination.	    test $existing_dest = no && break 3	  done	done      done    done  donedone(exit $fail); exit

⌨️ 快捷键说明

复制代码Ctrl + C
搜索代码Ctrl + F
全屏模式F11
增大字号Ctrl + =
减小字号Ctrl + -
显示快捷键?